<template>
  <div class="account-auction__completed">
    <p
      :class="info.isClass"
    >
      {{ info.text }}
    </p>
  </div>
</template>

<script>
  import { mapActions, mapGetters } from 'vuex'
  import STEPS from '@/constants/steps.js'

  export default {
    name: "StatusWinner",
    data () {
      return {
        STEP: STEPS
      }
    },
    computed: {
      ...mapGetters({
        order: 'account/order',
        canAcceptResource: 'account/canAcceptResource',
        canSubmitDoc:  'account/canSubmitDoc',
        buttonAcceptResource:  'account/buttonAcceptResource',
        buttonSignResource:  'account/buttonSignResource',
        participantUuid:  'user/participantUuid'
      }),
      isMainOrder () {
        return this.participantUuid === this.order?.contractorUuid
      },
      info () {
        const { orderStatus, status: lotStatus, contractorUuid } = this.order
        const { SEARCH, BOOKED, ALLOCATED, CANCELLED, WINNER } = this.STEP

        if (orderStatus === SEARCH && !contractorUuid && lotStatus === WINNER) {
          return {
            isClass: 'winner',
            text: 'Ваша ставка выиграла. Ожидаем решения логиста экспедитора.'
          }
        } else if ([ALLOCATED, BOOKED].includes(orderStatus) && lotStatus === WINNER && (!contractorUuid || !this.isMainOrder)) {
          return {
            isClass: 'loser',
            text: 'В аукционе у Вас хорошая ставка, но на заказ назначен другой перевозчик.'
          }
        } else if (orderStatus === BOOKED && lotStatus === WINNER && this.isMainOrder) {
          return {
            isClass: 'winnerGrey',
            text: 'Логист экспедитора назначил вас на этот рейс. Назначьте ресурсы для исполнения.'
          }
        } else if (orderStatus === ALLOCATED && lotStatus === WINNER && this.isMainOrder) {
          return {
            isClass: 'winnerGrey',
            text: 'Подпишите и отправьте заявку, чтобы начать исполнять заказ.'
          }
        } else if (orderStatus === CANCELLED && lotStatus === WINNER && this.isMainOrder) {
          return {
            isClass: 'common',
            text: 'Вас сняли с заказа. Уточните у ответственного менеджера детали.'
          }
        } else if (this.order.orderStatus === this.STEP.BOOKED && this.order.lotStatus !== this.STEP.CANCELLED && this.buttonAcceptResource) {
          return {
            isClass: 'common',
            text: 'Ресурсы назначены, ожидаем подверждение. Это может занять несколько минут'
          }
        } else if (this.order.orderStatus === this.STEP.BOOKED && this.order.lotStatus === this.STEP.CANCELLED) {
          return {
            isClass: 'loser',
            text: 'Вы не назначили вовремя машину. Мы вынуждены снять вас с заказа и понизить ваш рейтинг'
          }
        } else if (this.order.orderStatus === this.STEP.ALLOCATED && this.order.lotStatus === this.STEP.CANCELLED) {
          return {
            isClass: 'loser',
            text: 'Вы не подписали вовремя заявку. Мы вынуждены снять вас с заказа и понизить ваш рейтинг'
          }
        } else if (this.order.orderStatus === this.STEP.CONTRACTED && this.order.lotStatus !== this.STEP.CANCELLED) {
          return {
            isClass: 'common',
            text: 'Вы подписали заявку и перешли к исполнению заказа'
          }
        } else if (this.order.orderStatus === this.STEP.IN_PROCESS && this.order.lotStatus !== this.STEP.CANCELLED) {
          return {
            isClass: 'winner',
            text: 'Вы подписали заявку. Ждем вашу машину вовремя на погрузке!'
          }
        } else if (this.order.orderStatus === this.STEP.PROCESSED) {
          return {
            isClass: 'common',
            text: 'Вы успешно выполнили заказ. Заявка перенесана в архив'
          }
        } else {
          return {
            isClass: 'common',
            text: ''
          }
        }
      }
    },
    methods: {
      ...mapActions({
        acceptResource: 'account/acceptResource',
        requestExecution: 'account/requestExecution'
      })
    }
  }
</script>

<style scoped lang="scss">
  .account-auction__completed {
    font-size: 14px;
    line-height: 18px;
    padding-top: 10px;
    .common {
      color: $color-text-base;
    }
    .winner {
      color: $green-craiola;
    }
    .winnerGrey {
      color: $gray-slate;
      a {
        color:$color-blue-smalt;
      }
    }
    .loser {
      color: $color-error;
    }
  }
</style>
